/******************************************************************************
* CommandExecuter.h - header file for CommandExecuterClass.	              *
*******************************************************************************
* (C) Gershon Elber, Technion, Israel Institute of Technology                 *
*******************************************************************************
* Written by Moran Dringer and Shiran Maor, January 2013.		      *
******************************************************************************/

#ifndef COMMAND_HANDLER_H
#define COMMAND_HANDLER_H

#include <windows.h>

#include "AndroidServerDefs.h"
#include "AndroidParser.h"

/* CE = Command execute. */
enum {
    CE_RESULT_ERROR = -1,
    CE_RESULT_SUCCESS = 0
} typedef CEResultType;  

typedef struct ThreadDataStruct {
    AndroidCommandHandler TrdCommandHandler;
    AndrdCommandDataStruct CommandData;
} ThreadData, *PThreadData;

class CommandExecuterClass
{
    private:
        AndroidCommandHandler CmdCommandHandler;
        AndroidPrintFunction ThePrintFunction;
	unsigned int TheMaxEventPerSecond;
        AndroidParserClass TheParser;
        bool IsLeftButtonDown;
    private:
        HANDLE DownThread;
        DWORD DownThreadID;
        HANDLE ClicksThread;
        DWORD ClicksThreadID;    
    public:
        bool IsVerificatePasswordCommand;
        string PasswordFromUser;
    public:
        CommandExecuterClass(AndroidCommandHandler TheHandlerFunction,
			     AndroidPrintFunction PrintFunction,
			     unsigned int ThueMaxEventPerSecond,
			     char *TheCommandInput);
        ~CommandExecuterClass(void);
    private:
        CEResultType ExecuteCommandGps();
        CEResultType ExecuteCommandSensor(int TheCommandType);
        CEResultType ExecuteCommandTouch();
        CEResultType ExecuteCommandButton();
        CEResultType ExecuteCommandPhoneButton();
        CEResultType ExecuteCommandNotifyNoSensor();
        CEResultType ExecuteCommandShutdown();
        CEResultType ExecuteSelectCommand();
        CEResultType ExecuteCommandVerificatePassword();
    public:
        CEResultType ExecuteCommand();     
};
    
#endif /* COMMAND_HANDLER_H */
