/******************************************************************************
* MouseController.h - header file for MouseControllerClass.                   *
*******************************************************************************
* (C) Gershon Elber, Technion, Israel Institute of Technology                 *
*******************************************************************************
* Written by Moran Dringer and Shiran Maor, January 2013.		      *
******************************************************************************/

#ifndef MOUSE_CONTROLLER_H
#define MOUSE_CONTROLLER_H

#include <windows.h>

#include "AndroidServerDefs.h"

/* MC = MouseController. */
enum {
    MC_RESULT_ERROR = -1,
    MC_RESULT_SUCCESS = 0
} typedef MCResultType; 

class MouseControllerClass {
    public:
	MouseControllerClass(void);
	~MouseControllerClass(void);

	MCResultType GetCursorPos(POINT *ThePoint);
	MCResultType SetCursorPos(int x, int y);

	MCResultType Move(int dX, int dY);

	MCResultType LeftDown();
	MCResultType LeftUp();
	MCResultType LeftClick();

	MCResultType RightDown();
	MCResultType RightUp();
	MCResultType RightClick();

	MCResultType MiddleDown();
	MCResultType MiddleUp();
	MCResultType MiddleClick();

	MCResultType WheelRolledDown();
	MCResultType WheelRolledUp();
	MCResultType WheelRolled(int Postion);
};

bool MouseEmulationCommandHandler(AndrdCommandDataStruct CommandData);

#endif /* MOUSE_CONTROLLER_H */
