/******************************************************************************
* Parser.h - header file for ParserClass.               	              *
*******************************************************************************
* (C) Gershon Elber, Technion, Israel Institute of Technology                 *
*******************************************************************************
* Written by Moran Dringer and Shiran Maor, January 2013.		      *
******************************************************************************/

#ifndef ANDROID_PARSER_H
#define ANDROID_PARSER_H

#include <string>

enum {
    PARSER_RESULT_ERROR = -1,
    PARSER_RESULT_SUCCESS = 0
} typedef AndroidParserResultType; 

using std::string;

class AndroidParserClass {
    public:
        string StringLeftToParse;
        string TheParam;
        char TheInputDelimiter;
    public:
        AndroidParserClass(char* StringToParse);
        ~AndroidParserClass(void);
    private:
        int ParseNextParam();
        string GetTheParam();
    public:
        int ParseNextParamAndGetVal(int* TheParamVal);
        int ParseNextParamAndGetVal(long* TheParamVal);
        int ParseNextParamAndGetVal(double* TheParamVal);
        int ParseNextParamAndGetVal(string* TheParamVal);
};

#endif /* ANDROID_PARSER_H */
