/******************************************************************************
* BluetotohServer.h - header file for BluetoothServerClass.	              *
* This class implments server that talks with android device via bluetooth.   *
*******************************************************************************
* (C) Gershon Elber, Technion, Israel Institute of Technology                 *
*******************************************************************************
* Written by Moran Dringer and Shiran Maor, January 2013.		      *
******************************************************************************/

#ifndef BLUETOOTH_SERVER_H
#define BLUETOOTH_SERVER_H

#include <winsock2.h>
#include <ws2bth.h>
#include <string>
#include "AndroidServer.h"

using std::string;

class BluetoothServerClass : public AndroidServerClass
{
    private:
	WSADATA WSAData;
	SOCKET LocalSocket;
	SOCKADDR_BTH SockAddrBthLocal;
	int AddrLen;
	LPCSADDR_INFO PAddrInfo;
	WSAQUERYSET QuerySet;
	SOCKET ClientSocket;
	char *PDataBuffer;
	int DataBufferIndex;
    public:
	BluetoothServerClass(void);
	virtual ~BluetoothServerClass(void);
    private:
	AndrdResultType InitWinSoc();   
	AndrdResultType OpenBluetoothSocket();
	AndrdResultType Bind();
	AndrdResultType GetSocketName();
	AndrdResultType InitAddrInfo();
	AndrdResultType InitQuerySet();
	AndrdResultType SetService();
	AndrdResultType Listen();
	AndrdResultType Accept();
	AndrdResultType VerificatePassword(string Password);
	AndrdResultType SendOk();
	AndrdResultType SendNotOk();
	AndrdResultType InitBuffer();
	AndrdResultType ReadTotalLengthToRead(int* PSizeToRead);
	AndrdResultType ReadFromStream();
	AndrdResultType ExecuteCommand();
    public:
	virtual AndrdResultType  InitCommunication();
	virtual AndrdResultType  OnConnecting();
	virtual AndrdResultType  OnConnected();
	virtual AndrdResultType  OnDisconnecting();
};

#endif /* BLUETOOTH_SERVER_H */
