/******************************************************************************
* CommandExecuter.h - header file for CommandExecuterClass.	              *
*******************************************************************************
* (C) Gershon Elber, Technion, Israel Institute of Technology                 *
*******************************************************************************
* Written by Moran Dringer and Shiran Maor, January 2013.		      *
******************************************************************************/

#ifndef COMMAND_HANDLER_H
#define COMMAND_HANDLER_H

#include "Parser.h"


typedef void (*CommandHandler)(int, double, double, double);

/* CE = Command execute. */
enum
{
    CE_RESULT_ERROR = -1,
    CE_RESULT_SUCCESS = 0
} typedef CEResultType;  


class CommandExecuterClass
{
private:
    CommandHandler TheCommandHandler;
    ParserClass TheParser;
    bool IsLeftButtonDown;
public:
    bool IsVerificatePasswordCommand;
    string PasswordFromUser;
public:
    CommandExecuterClass(CommandHandler TheHandlerFunction,
                         char * TheCommandInput);
    ~CommandExecuterClass(void);
private:
    CEResultType ExecuteTouchCommand();
    CEResultType ExecuteButtonCommand();
    CEResultType ExecuteGravityCommand();
    CEResultType ExecuteGyroCommand();
    CEResultType ExecuteLinearAccelerationCommand();
    CEResultType ExecuteSelectCommand();
    CEResultType ExecuteVerificatePasswordCommand();
public:
    CEResultType ExecuteCommand();
};
    
#endif /* COMMAND_HANDLER_H */
