#ifndef GC_COMPRESSED_INPUT_VECTORS_TREE_H
#define GC_COMPRESSED_INPUT_VECTORS_TREE_H

/****************************************************************************/
/* Type definitions *********************************************************/
/****************************************************************************/

typedef cl_uint GC_TreeNodeValueType;

/****************************************************************************/
/* Structs ******************************************************************/
/****************************************************************************/

struct GC_CompressedInputVectorsTreeNode {

    GC_NrOfWeightsType                        NrOfOccurrences;
    struct GC_CompressedInputVectorsTreeNode* v0;
    struct GC_CompressedInputVectorsTreeNode* v1;

};

typedef struct GC_CompressedInputVectorsTreeNode GC_CompressedInputVectorsTreeNode;

/****************************************************************************/
/* Functions ****************************************************************/
/****************************************************************************/

GC_CompressedInputVectorsTreeNode* InitTree
    ();

GC_CompressedInputVectorsTreeNode* CreateNewNode
    ();

void InsertToTree
    (      GC_CompressedInputVectorsTreeNode*   Tree,
     const GC_TreeNodeValueType*                Values,
     const GC_InputVectorIndexType              NrOfValues,
           GC_LargestUnsignedIntegerType*       Count,
           GC_NrOfWeightsType*                  MaxWeight);

GC_CompressedInputVectorsTreeNode* CreateBranch
    (const GC_TreeNodeValueType*                Values,
     const GC_LargestUnsignedIntegerType        NrOfValues);

void DeleteTree
    (      GC_CompressedInputVectorsTreeNode*   Tree);

/****************************************************************************/

#endif /* GC_COMPRESSED_INPUT_VECTORS_TREE_H */