#ifndef GC_STOP_WATCH_H
#define GC_STOP_WATCH_H

/****************************************************************************/

#include <time.h>

/****************************************************************************/

#include "GC.h"

/****************************************************************************/
/**/                                                                      /**/
/**/ #define MAX_TIME_STRING_LENGTH             (16u)                     /**/
/**/ #define TIME_STRING_FORMAT                 "%02d:%02d:%02d:%03d"     /**/
/**/                                                                      /**/
/**/ #define NR_OF_MICROSECONDS_PER_MILLISECOND (1000u)                   /**/
/**/ #define NR_OF_MICROSECONDS_PER_SECOND      (1000000u)                /**/
/**/ #define NR_OF_MICROSECONDS_PER_MINUTE      (60000000u)               /**/
/**/ #define NR_OF_MICROSECONDS_PER_HOUR        (3600000000u)             /**/
/**/                                                                      /**/
/****************************************************************************/

/****************************************************************************/
/* GC_StopWatchStruct structure *********************************************/
/****************************************************************************/

typedef struct {

    GC_CharacterType TimeString[MAX_TIME_STRING_LENGTH];

    clock_t          StartTime;
    clock_t          StopTime;

    clock_t          LapStartTime;
    clock_t          LapStopTime;

} GC_StopWatchStruct;

/****************************************************************************/
/* functions of GC_StopWatchStruct structure ********************************/
/****************************************************************************/

GC_CharacterType* StoreElapsedTimeAsString
    (      GC_StopWatchStruct* Self);

GC_CharacterType* StoreLapTimeAsString
    (      GC_StopWatchStruct* Self);

GC_LargestUnsignedIntegerType GetLapTimeInMilliSeconds
    (const GC_StopWatchStruct* Self);

void Start
    (      GC_StopWatchStruct* Self);

void StartLap
    (      GC_StopWatchStruct* Self);

void Stop
    (      GC_StopWatchStruct* Self);

void StopLap
    (      GC_StopWatchStruct* Self);

/****************************************************************************/

#endif /* GC_STOP_WATCH_H */