
#ifndef NI_USER_TRACKER_H
#define NI_USER_TRACKER_H

struct RawKinectEventClass
{
public:

    int ValidEvent;


    float GetHeadX() {return HeadX;};
    float GetHeadY() {return HeadY;};
    float GetHeadZ() {return HeadZ;};
    void SetHeadX(float num) {HeadX = num;};
    void SetHeadY(float num) {HeadY = num;};
    void SetHeadZ(float num) {HeadZ = num;};

    float GetLeftX() {return LeftX;};
    float GetLeftY() {return LeftY;};
    float GetLeftZ() {return LeftZ;};
    void SetLeftX(float num) {LeftX = num;};
    void SetLeftY(float num) {LeftY = num;};
    void SetLeftZ(float num) {LeftZ = num;};
    float GetRightX() {return RightX;};
    float GetRightY() {return RightY;};
    float GetRightZ() {return RightZ;};
    void SetRightX(float num) {RightX = num;};
    void SetRightY(float num) {RightY = num;};
    void SetRightZ(float num) {RightZ = num;};

    void SetLeftCount(int num) {LeftCount = num;};
    void SetRightCount(int num) {RightCount = num;};
    void SetLeftLoop(int num) {LeftLoop = num;};
    void SetRightLoop(int num) {RightLoop = num;};
    int GetLeftCount() {return LeftCount;};
    int GetRightCount() {return RightCount;};
    int GetLeftLoop() {return LeftLoop;};
    int GetRightLoop() {return RightLoop;};

    void SetLeftAngle(int i, double val) { LeftAngles[i] = val;};
    void SetRightAngle(int i, double val) { RightAngles[i] = val;};
    double GetLeftAngle(int i) {return LeftAngles[i];};
    double GetRightAngle(int i) {return RightAngles[i];};

    float WindowX, WindowY, WindowW, WindowH, WindowZ;

private:
    float LeftX, LeftY, LeftZ, RightX, RightY, RightZ, HeadX, HeadY, HeadZ;
    int LeftCount, RightCount, LeftLoop, RightLoop;
    
    double LeftAngles[5];
    double RightAngles[5];

};

extern "C" RawKinectEventClass * GuIritKinectUpdate();
extern "C" int GuIritKinectInit(int mode = 0, char* FileName = NULL, bool ShowWindows = true);
extern "C" bool GuIritKinectStop();



#endif /* NI_USER_TRACKER_H */