#ifndef ITERPRETER_H_
#define ITERPRETER_H_

#include <queue>
#include "cv.h"
using namespace cv;
using namespace std;

#define DEFAULT_HAND_SIZE 100




class HandClass
{

public:
    Mat Cropped;
    Mat Silhouette;
    CvPoint Center;
    CvPoint3D32f RealPos;
    int Distance;
    int ErodeFactor;
    cv::Rect HandRect;

    int BlobCount;
    int Click;

    double Angles[5];

    bool novel;
};

class HandQueue
{

public:
    unsigned int MaxSize;
    CvPoint CenterAverage;
    int DistanceAverage;
    int FingersAverage;
    CvPoint3D32f PositionAverage;

    deque<int> DistanceQueue;
    deque<int> FingersQueue;
    deque<CvPoint> CenterQueue;

    deque<CvPoint3D32f> PositionQueue;

    HandQueue();
    void PushHand(HandClass *Hand);
    void HandQueue::CalculateAverages();
};



class InterpreterClass
{
    
public:

    bool ValidFrame;

    Mat Src, Disp, Hand;
    int HandWindow;

    HandClass *Left, *Right;
    HandQueue *LeftQueue, *RightQueue;

    int ErodeFactor;
    int BlobCount; 

    InterpreterClass();
    ~InterpreterClass() {
	delete Left;
	delete Right;
    }

    void test();

    void InitParams(int num); 
    void setSrcImage ( float* pTexBuf, int raw_width, int raw_height, int width, int height);
    void draw(XnPoint3D SkelRight, XnPoint3D SkelLeft, bool Valid);
    void PrintStatus();
    
    bool ProcessHand (HandClass * Hand, XnPoint3D SkeletonPointWorld, XnPoint3D SkeletonPointImage);
    bool CropHand (HandClass * Hand, Mat DepthImage, XnPoint3D SkeletonPointImage);
    bool ComputePalmCOG (HandClass * Hand);
    bool DetectLoops(HandClass * Hand);
    bool DetectFingers(HandClass * Hand);


	int prepareHand(HandClass * Hand, Mat Disp, float PosX, float PosY); // prepare a Mat of the hands, and set hand position in 
    void analyzeHand(HandClass * Hand); // Using 
    int CountFingers(HandClass * Hand);

    void FreeMats();
    int FindLoops(Mat MyMat);
    int Click;

    void drawHand(HandClass * Hand, char *WindowName);
};

#endif
